/*
 * vdctl.c
 * original code: SASANO Takayoshi
 * --- public domain, no warranty.
 */

#include "vdclient.h"

LOCAL	TC	DrvName[] = {TK_v, TK_d, TK_QSTN, TK_NULL};
LOCAL	TC	CtlName[] = {TK_v, TK_d, TK_c, TK_t, TK_l, TK_QSTN, TK_NULL};
#define	DRVCHAR	2			/* DrvName$B$N!"(BTK_QSTN$B$N0LCV(B */
#define	CTLCHAR	5			/* CtlName$B$N!"(BTK_QSTN$B$N0LCV(B */

/* BTRON process$B"*(Bvdtask */
LOCAL	WERR	write_reply(DrvWork *wk, DevReq *q, DevRsp *p)
{
	VDCTL_HDR	*hdr = (VDCTL_HDR *)q->memptr;
	W	size;
	WERR	err;

	/* $BIT@5$J>uBV(B */
	if (!wk->c_attach ||		/* $B2>A[%\%j%e!<%`>uBV$,(Bdetach$B$G$"$k(B */
	    !wk->c_respstage) {		/* response stage$B$G$J$$(B */
		D(0, ("write_reply: invalid status  attach:%d resp:%d\n",
		      wk->c_attach, wk->c_respstage));
		err = ER_DEV;
		goto fin0;
	}

	D(3, ("write_reply: cmd %d start %d size %d addr %x error %d\n",
	      hdr->cmd, hdr->start, hdr->size, hdr->addr, hdr->error));

	/* $B%X%C%@$NFbMF$KLdBj$,L5$$$+%A%'%C%/(B */
	switch (hdr->cmd) {
	case	VDCMD_EJECT:
	case	VDCMD_MAP:
		break;
	default:
		D(0, ("write_reply: hdr->cmd %d\n", hdr->cmd));
		err = ER_OBJ;
		goto fin0;
	}

	size = sizeof(VDCTL_HDR);
	if (q->datacnt < size) {
		D(0, ("write_reply: q->datacnt %d\n", q->datacnt));
		err = ER_PAR;
		goto fin0;
	}

	/* $B%l%9%]%s%9$NFbMF$rJ]B8(B */
	memcpy(&wk->c_hdr, hdr, sizeof(VDCTL_HDR));

	/* vdtask$B$XDLCN(B */
	err = set_flg(wk->c_flgid, FLAG_RESPONSE);
	if (err < ER_OK) {
		D(0, ("write_reply: set_flg %d\n", err));
		goto fin0;
	}

	/* command stage$B$X(B */
	wk->c_respstage = FALSE;
	p->datacnt = size;
	err = ER_OK;
 fin0:
	return err;
}

/* vdtask$B"*(BBTRON process */
LOCAL	WERR	read_cmd(DrvWork *wk, DevReq *q, DevRsp *p)
{
	VDCTL_HDR	*hdr = &wk->c_hdr;
	UW	flgptn;
	W	size;
	WERR	err;

	/* $BIT@5$J>uBV(B */
	if (!wk->c_attach ||		/* $B2>A[%\%j%e!<%`>uBV$,(Bdetach$B$G$"$k(B */
	    wk->c_respstage) {		/* command stage$B$G$J$$(B */
		D(0, ("read_reply: invalid status  attach:%d resp:%d\n",
		      wk->c_attach, wk->c_respstage));
		err = ER_DEV;
		goto fin0;
	}

	/* vdtask$B$+$i$N%3%^%s%IBT$A(B */
	err = twai_flg(&flgptn, wk->c_flgid, FLAG_COMMAND,
		       TWF_ORW, wk->c_cmdtmo);
	if (err < ER_OK) {
		D(0, ("read_cmd: wai_flg %d\n", err));
		goto fin0;
	}

	D(3, ("read_cmd: cmd %d start %d size %d\n",
	      hdr->cmd, hdr->start, hdr->size));

	/* $B%X%C%@$NFbMF$KLdBj$,L5$$$+%A%'%C%/(B */
	switch (hdr->cmd) {
	case	VDCMD_EJECT:
	case	VDCMD_MAP:
		break;
	default:
		D(0, ("read_cmd: hdr->cmd %d\n", hdr->cmd));
		err = ER_OBJ;
		goto fin0;
	}

	size = sizeof(VDCTL_HDR);
	if (q->datacnt < size) {
		D(0, ("read_cmd: q->datacnt %d\n", q->datacnt));
		err = ER_PAR;
		goto fin0;
	}

	/* $B%3%^%s%I$rFbIt$N%P%C%U%!$+$i%3%T!<(B */
	memcpy(q->memptr, hdr, sizeof(VDCTL_HDR));

	/* $B%U%i%0$N>C5n(B */
	err = clr_flg(wk->c_flgid, ~FLAG_COMMAND);
	if (err < ER_OK) {
		D(0, ("read_cmd: clr_flg %d\n", err));
		goto fin0;
	}

	/* response stage$B$X(B */
	wk->c_respstage = TRUE;
	p->datacnt = size;
	err = ER_OK;
 fin0:
	return err;
}

/* $B2>A[%\%j%e!<%`>pJs$NEPO?(B */
LOCAL	WERR	set_devinfo(DrvWork *wk, DevReq *q, DevRsp *p)
{
	VDCTL_DEVINFO	*vdi = (VDCTL_DEVINFO *)q->memptr;
	ERR	err;
	W	size;
	DevDef	dd;
	DiskInfo	di;
	DiskEvt	evt;

	/* $BIT@5$J>uBV(B */
	if (wk->c_attach) {		/* $B2>A[%\%j%e!<%`>uBV$,(Battach$B$G$"$k(B */
		D(0, ("set_devinfo: invalid status  attach:%d\n",
		      wk->c_attach));
		err = ER_BUSY;
		goto fin0;
	}

	/* $B%G!<%?%5%$%:3NG'(B */
	if (q->datacnt < sizeof(VDCTL_DEVINFO)) {
		err = ER_PAR;
		goto fin0;
	}

	/* $B%G!<%?FbMF3NG'(B */
	if ((vdi->devkind & 0xf0) != DK_DISK ||	/* $B%G%#%9%/$8$c$J$$(B */
	    vdi->mapsect < 1	||		/* $B%^%C%W%;%/%??t$,(B1$BL$K~(B */
	    vdi->diskinfo.blocksize < 1 ||	/* $B%V%m%C%/%5%$%:$,(B1$BL$K~(B */
	    vdi->diskinfo.blockcont < 1) {	/* $BAm%V%m%C%/?t$,(B1$BL$K~(B */
		D(0, ("set_devinfo: kind:%x map:%d bsz:%d bcnt:%d\n",
		      vdi->devkind, vdi->mapsect,
		      vdi->diskinfo.blocksize, vdi->diskinfo.blockcont));
		err = ER_OBJ;
		goto fin0;
	}

	/* $B%G%P%$%9EPO?(B */
	memset(&dd, 0, sizeof(dd));
	dd.attr.devinfo  = wk->drvno;
	dd.attr.devkind  = vdi->devkind;
	dd.attr.reserved = 0;		/* $BM=Ls(B(0) */
	dd.attr.openreq  = 0;		/* open/close$B$r$=$NETEYJs9p$7$J$$(B */
	dd.attr.lockreq  = 0;		/* lock$BITMW(B */
	dd.attr.diskinfo = 1;		/* diskinfo$B$"$j(B */
	dd.attr.chardev  = 0;		/* block device */
	dd.attr.nowait   = 0;		/* nowait$BHsBP1~(B */
	dd.attr.eject    = 1;		/* eject$BBP1~(B */
	dd.subunits      = 0;		/* subunit$BL5$7(B */
	DrvName[DRVCHAR] = TK_a + wk->drvno;
	memcpy(dd.name, DrvName, sizeof(DrvName));
	dd.portid        = wk->t_porid;

	di = vdi->diskinfo;
	di.removable = 1;

	err = DefDevice(&dd, &di);
	if (err < ER_OK) {
		D(0, ("set_devinfo: DefDevice %d\n", err));
		goto fin0;
	}
	wk->t_devid    = err;
	wk->c_devdef   = dd;
	wk->c_diskinfo = di;
	wk->t_mapsect  = vdi->mapsect;
	wk->t_mapaddr  = vdi->mapaddr;
	wk->t_mapstart = vdi->mappos;
	wk->c_mapmax   = vdi->mapsect;
	wk->c_cmdtmo   = vdi->cmdtmo;
	wk->c_resptmo  = vdi->resptmo;

	/* $B%^%C%W%P%C%U%!$N3NJ](B */
	size = wk->t_mapsect * wk->c_diskinfo.blocksize;
	wk->c_bufaddr = Kmalloc(size);
	if (wk->c_bufaddr == NULL) {
		D(0, ("set_devinfo: wk->c_bufaddr NULL\n"));
		err = ER_NOMEM;
		goto fin0;
	}

	/* $B%^%C%WNN0h$r%^%C%W%P%C%U%!$X%3%T!<(B */
	err = CheckSpaceR(wk->t_mapaddr, size);
	if (err < ER_OK) {
		D(0, ("set_devinfo: CheckSpaceR %d\n", err));
		goto fin1;
	}
	memcpy(wk->c_bufaddr, wk->t_mapaddr, size);

	/* $B2>A[%\%j%e!<%`>uBV(B: attached, $B%3%^%s%I<u?.%9%F!<%8(B */
	wk->c_attach = TRUE;
	wk->c_respstage = FALSE;

	p->datacnt = sizeof(VDCTL_DEVINFO);

	/* $BI,MW$K1~$8!";v>]DLCN$r9T$&(B */
	if (wk->t_mbfid) {
		evt.kind  = DE_MOUNT;
		evt.devid = wk->t_devid; 
		evt.info  = 0;

		err = tsnd_mbf(wk->t_mbfid, &evt, sizeof(evt), TMO_POL);
		if (err < ER_OK) {
			D(0, ("write_dn_diskevent: tsnd_mbf %d\n", err));
		}
	}

	err = ER_OK;
	goto fin0;
 fin1:
	if (wk->c_bufaddr != NULL) {
		Kfree(wk->c_bufaddr);
		wk->c_bufaddr = NULL;
	}
 fin0:
	return err;
}

/* $B2>A[%\%j%e!<%`>pJs$NKu>C(B */
LOCAL	WERR	clear_devinfo(DrvWork *wk)
{
	ERR	err;
	DiskEvt	evt;

	/* $B2>A[%\%j%e!<%`>uBV(B: detached, $B%3%^%s%I<u?.%9%F!<%8(B */
	wk->c_attach = FALSE;
	wk->c_respstage = FALSE;

	/* $B%^%C%W%P%C%U%!$N2rJ|(B */
	if (wk->c_bufaddr != NULL) {
		Kfree(wk->c_bufaddr);
		wk->c_bufaddr = NULL;
	}

	/* $B%G%P%$%9EPO?$NKu>C$O9T$o$J$$!J9T$($J$$!K(B */

	/* $B;v>]DLCN(B */
	if (wk->t_mbfid) {
		evt.kind  = DE_EJECT;
		evt.devid = wk->t_devid;
		evt.info  = 0;

		err = tsnd_mbf(wk->t_mbfid, &evt, sizeof(evt), TMO_POL);
		if (err < ER_OK) {
			D(0, ("clear_devinfo: tsnd_mbf %d\n", err));
		}
	}

	return ER_OK;
}

/* read$BMW5a(B */
LOCAL	ERR	ctl_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return read_cmd(wk, q, r);

	return ER_PAR;
}

/* write$BMW5a(B */
LOCAL	ERR	ctl_write(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return write_reply(wk, q, r);

	switch (q->datano) {
	case	DN_VDSETDISKINFO:	return set_devinfo(wk, q, r); 
	case	DN_VDCLEARDISKINFO:	return clear_devinfo(wk);
	default:			return ER_PAR;
	}
}

/* abort$BMW5a(B */
EXPORT	ERR	ctl_abort(DrvWork *wk, ID tskid)
{
	ERR	err;
	T_RFLG	rflg;

	/* $B%$%Y%s%H%U%i%0>uBV$r<hF@(B */
	err = ref_flg(&rflg, wk->c_flgid);
	if (err < ER_OK) {
		D(0, ("ctl_abort: ref_flg %d\n", err));
		goto fin0;
	}

	/* $B;XDj$7$?%?%9%/(BID$B$rBT$?$;$F$$$k$N$G$"$l$P!"BT$A>uBV$r2r=|(B */
	err = (rflg.wtsk == tskid) ? rel_wai(tskid) : ER_OK;

	if (err < ER_OK) {
		D(0, ("ctl_abort: rel_wai %d\n", err));
		goto fin0;
	}

 fin0:
	return err;
}

/* $B3F<oMW5a=hM}(B */
LOCAL	ERR	ctl_request(DrvWork *wk, DevReq *q, DevRsp *r)
{
	switch (q->cmd.cmd) {
		/* $BDL>oMW5a(B */
	case	DC_READ:	return ctl_read(wk, q, r);
	case	DC_WRITE:	return ctl_write(wk, q, r);

	case	DC_OPEN:
	case	DC_CLOSE:
	case	DC_CLOSEALL:	return clear_devinfo(wk);

		/* $BFC<lMW5a(B */
	case	DC_ABORT:	return ctl_abort(wk, wk->c_tskid_normal);
	case	DC_SUSPEND:
	case	DC_RESUME:	return ER_OK;	/* $B2?$b$7$J$$!J;CDj!K(B */

		/* $B$=$NB>(B */
	default:		return ER_NOSPT;
	}
}

/* $B%I%i%$%P!&=hM}%?%9%/(B */
LOCAL	void	ctl_task(UW calptn)
{
	ERR	err;
	RNO	rdvno;
	W	size;
	T_RTSK	rtsk;
	DevReq	q;
	DevRsp	r;
	DrvWork	*wk;

	/* $B%?%9%/>pJs$N<hF@(B */
	err = ref_tsk(&rtsk, TSK_SELF);
	if (err < ER_OK) {
		D(0, ("ctl_task: ref_tsk %d\n", err));
		goto fin0;
	}
	wk = rtsk.exinf;

	while (1) {
		/* $BMW5aBT$A(B */
		err = acp_por(&rdvno, (VP)&q, &size, wk->c_porid, calptn);
		if (err < ER_OK) goto fin1;

		/* $BIT@5$J%Q%1%C%H$OL5;k(B */
		if (size != sizeof(q)) {
			D(0, ("ctl_task: bad size %d\n", size));
			continue;
		}

		D(4, ("ctl_task: cmd %d datano %d datacnt %d memptr %x\n",
		      q.cmd.cmd, q.datano, q.datacnt, q.memptr));

		/* $B%?%9%/6u4V$N@Z$jBX$((B */
		err = taskspace_select(&q);
		if (err < ER_OK) {
			D(0, ("ctl_task: taskspace_select %d\n", err));
		}

		/* $BJVEzMQ%Q%1%C%H$N=`Hw$*$h$SMW5a=hM}$N<B9T(B */
		r.devid     = q.devid;
		r.cmd       = q.cmd;
		r.datano    = q.datano;
		r.datacnt   = 0;
		r.error.err = (err < ER_OK) ? err : ctl_request(wk, &q, &r);

		/* $B%i%s%G%V$X$NJVEz(B */
		err = rpl_rdv(rdvno, (VP)&r, sizeof(r));
		if (err < ER_OK) D(0, ("ctl_task: rpl_rdv %d\n", err));
	}

 fin1:
	if (wk->c_bufaddr != NULL) {
		Kfree(wk->c_bufaddr);
		wk->c_bufaddr = NULL;
	}
	del_por(wk->c_porid);
	del_flg(wk->c_flgid);
 fin0:
	exd_tsk();
}

/* $B%I%i%$%P5/F0(B */
EXPORT	ERR	ctl_start(DrvWork *wk)
{
	WERR	err;
	T_CFLG	cflg;
	T_CPOR	cpor;
	T_CTSK	ctsk;
	DevDef	dd;

	/* $B%$%Y%s%H%U%i%0:n@.(B */
	cflg.exinf   = (VP)CH4toW('v', 'd', 'c', 'a' + wk->drvno);
	cflg.flgatr  = TA_WSGL;
	cflg.iflgptn = 0;
	err = vcre_flg(&cflg);
	if (err < ER_OK) goto fin0;
	wk->c_flgid = (ID)err;

	/* $B%i%s%G%V%]!<%H:n@.(B */
	cpor.exinf   = cflg.exinf;
	cpor.poratr  = TA_NULL;
	cpor.maxcmsz = sizeof(DevReq);
	cpor.maxrmsz = sizeof(DevRsp);
	err = vcre_por(&cpor);
	if (err < ER_OK) goto fin1;
	wk->c_porid = (ID)err;

	/* $B%?%9%/:n@.!JDL>oMW5a!K(B */
	ctsk.exinf   = wk;
	ctsk.task    = ctl_task;
	ctsk.itskpri = CTLTASK_PRI;
	ctsk.stksz   = CTLTASK_STKSZ;
	ctsk.tskatr  = TA_HLNG | TA_RNG0;
	err = vcre_tsk(&ctsk);
	if (err < ER_OK) goto fin2;
	wk->c_tskid_normal = (ID)err;

	/* $B%?%9%/:n@.!JFC<lMW5a!K(B */
	err = vcre_tsk(&ctsk);
	if (err < ER_OK) goto fin3;
	wk->c_tskid_abort = (ID)err;

	/* $B%?%9%/5/F0!JDL>oMW5a!K(B */
	err = sta_tsk(wk->c_tskid_normal, D_NORM_PTN);
	if (err < ER_OK) goto fin4;

	/* $B%?%9%/5/F0!JFC<lMW5a!K(B */
	err = sta_tsk(wk->c_tskid_abort, D_ABORT_PTN);
	if (err < ER_OK) goto fin5;

	/* $B%G%P%$%9EPO?(B */
	memset(&dd, 0, sizeof(dd));
	dd.attr.devinfo  = wk->drvno;
	dd.attr.devkind  = DK_UNDEF;	/* $BFC$KDj5A$7$J$$(B */
	dd.attr.reserved = 0;		/* $BM=Ls(B(0) */
	dd.attr.openreq  = 0;		/* open/close$B$r$=$NETEYJs9p$7$J$$(B */
	dd.attr.lockreq  = 0;		/* lock$BITMW(B */
	dd.attr.diskinfo = 0;		/* diskinfo$BL5$7(B */
	dd.attr.chardev  = 1;		/* character device */
	dd.attr.nowait   = 0;		/* nowait$BHsBP1~(B */
	dd.attr.eject    = 0;		/* eject$BHsBP1~(B */
	dd.subunits      = 0;		/* subunit$BL5$7(B */
	CtlName[CTLCHAR] = TK_a + wk->drvno;
	memcpy(dd.name, CtlName, sizeof(CtlName));
	dd.portid        = wk->c_porid;

	err = DefDevice(&dd, NULL);
	if (err < ER_OK) goto fin6;
	wk->c_devid = err;
	goto fin0;

 fin6:
	ter_tsk(wk->c_tskid_abort);
 fin5:
	ter_tsk(wk->c_tskid_normal);
 fin4:
	del_tsk(wk->c_tskid_abort);
 fin3:
	del_tsk(wk->c_tskid_normal);
 fin2:
	del_por(wk->c_porid);
 fin1:
	del_flg(wk->c_flgid);
 fin0:
	return err;
}

/* $B%I%i%$%P=*N;(B */
EXPORT	ERR	ctl_finish(DrvWork *wk)
{
	if (wk != NULL) {
		del_por(wk->c_porid);	/* $B$3$l$r;&$;$P<+LG$9$k(B */
	}

	return ER_OK;
}

/* map sector */
EXPORT	ERR	ctl_mapsect(DrvWork *wk, W start, VP *addr, W size)
{
	ERR	err;
	UW	flgptn;
	VDCTL_HDR	*hdr = &wk->c_hdr;
	
	/* $B%X%C%@:n@.(B */
	memset(hdr, 0, sizeof(VDCTL_HDR));
	hdr->cmd   = VDCMD_MAP;
	hdr->start = start;
	hdr->size  = size;
	hdr->addr  = NULL;
	hdr->error = ER_SYS;

	/* $B%U%i%0$r=i4|2=(B */
	err = clr_flg(wk->c_flgid, 0);
	if (err < ER_OK) {
		D(0, ("ctl_mapsect: clr_flg %d\n", err));
		goto fin0;
	}

	/* $B%3%^%s%IAw?.(B */
	err = set_flg(wk->c_flgid, FLAG_COMMAND);
	if (err < ER_OK) {
		D(0, ("ctl_mapsect: set_flg %d\n", err));
		goto fin0;
	}

	/* $B%l%9%]%s%9BT$A(B */
	err = twai_flg(&flgptn, wk->c_flgid, FLAG_RESPONSE,
		       TWF_ORW | TWF_CLR, wk->c_resptmo);
	if (err < ER_OK) {
		D(0, ("ctl_mapsect: twai_flg %d\n", err));
		goto fin0;
	}

	/* $B7k2L$r3JG<(B */
	err = hdr->error;
	if (err < ER_OK) {
		D(0, ("ctl_mapsect: hdr->error %d\n", err));
	}
	if (addr  != NULL) *addr  = (err < ER_OK) ? NULL : hdr->addr;
 fin0:
	return err;
}

/* eject */
EXPORT	ERR	ctl_eject(DrvWork *wk)
{
	VDCTL_HDR	*hdr = &wk->c_hdr;
	ERR	err = ER_OK;
	UW	flgptn;

	/* $B%X%C%@:n@.(B */
	memset(hdr, 0, sizeof(VDCTL_HDR));
	hdr->cmd   = VDCMD_EJECT;
	hdr->error = ER_SYS;
		
	/* $B%U%i%0$N=i4|2=(B */
	err = clr_flg(wk->c_flgid, 0);
	if (err < ER_OK) {
		D(0, ("ctl_eject: clr_flg %d\n", err));
		goto fin0;
	}

	/* $B%3%^%s%IAw?.(B */
	err = set_flg(wk->c_flgid, FLAG_COMMAND);
	if (err < ER_OK) {
		D(0, ("ctl_eject: set_flg %d\n", err));
		goto fin0;
	}

	/* $B%l%9%]%s%9BT$A(B */
	err = twai_flg(&flgptn, wk->c_flgid, FLAG_RESPONSE,
		       TWF_ORW | TWF_CLR, wk->c_resptmo);
	if (err < ER_OK) {
		D(0, ("ctl_eject: twai_flg %d\n", err));
		goto fin0;
	}

	/* $B7k2L$r3JG<(B */
	err = hdr->error;
	if (err < ER_OK) {
		D(0, ("ctl_eject: pkt->hdr.error %d\n", err));
		goto fin0;
	}

	clear_devinfo(wk);

 fin0:
	return err;
}
