/*
 * vddrv.c
 * code: SASANO Takayoshi
 * --- public domain, no warranty
 */

#include "vdclient.h"

#define	SECB(x)	((x) * wk->c_diskinfo.blocksize)

/* DN_DISKEVENT(w) */
LOCAL	ERR	write_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r)
{
	ERR	err;

	D(3, ("write_dn_diskevent: datacnt %d mbfid %d\n",
	      q->datacnt, *(ID *)q->memptr));

	/* ٤񤭹Ǥʤ */
	if (q->datacnt < sizeof(ID)) {
		err = ER_PAR;
		goto fin0;
	}

	/* ΤоݤȤʤåХåե */
	wk->t_mbfid = *(ID *)q->memptr;
	r->datacnt = sizeof(ID);

	err = ER_OK;
 fin0:
	return err;
}

/* DN_DISKFORMAT(w) ̤ */
LOCAL	ERR	write_dn_diskformat(DrvWork *wk, DevReq *q, DevRsp *r)
{
	D(3, ("write_dn_diskformat: datacnt %d diskformat %d\n",
	      q->datacnt, *(DiskFormat *)q->memptr));

	/* 񤭹ߤػߤƤ */
	if (wk->c_diskinfo.protect) return ER_RONLY;

	/* եޥåȷ(DiskFormat)Υå */
	/* Ŭʥǡ */

	r->datacnt = sizeof(DiskFormat);

	return ER_OK;
}

/* DN_DISKINIT(w) */
LOCAL	ERR	write_dn_diskinit(DrvWork *wk, DevReq *q, DevRsp *r)
{
	D(3, ("write_dn_diskformat: datacnt %d diskinit %d\n",
	      q->datacnt, *(DiskInit *)q->memptr));

	if (q->datacnt < sizeof(DiskInit) ||
	    *(DiskInit *)q->memptr != DISKINIT) return ER_PAR;

	/* Ͽ */

	r->datacnt = sizeof(DiskInit);

	return ER_OK;
}

/* ۥܥ塼Υޥå */
LOCAL	ERR	map_volume(DrvWork *wk, DevReq *q, W pos, W size)
{
	ERR	err;
	VP	mapaddr;

	if (wk->t_mapaddr != NULL &&	/* ˥ޥåפƤ */
	    pos >= wk->t_mapstart &&	/* andޥåϰ */
	    pos + size <= wk->t_mapstart + wk->t_mapsect) return ER_OK;

	/* ƥޥå׳ */
	wk->t_mapaddr = NULL;

	/* ޥå׵ */
	err = ctl_mapsect(wk, pos, &mapaddr, size);
	if (err < ER_OK) {
		D(0, ("map_volume: ctl_mapsect %d\n", err));
		goto fin0;
	}

	D(3, ("map_volume: sect %d @ %x - %x\n",
	      pos, mapaddr, mapaddr + SECB(size) - 1));

	/* ɥ쥹֤򥵡Хץڤؤ */
	err = SetTaskSpace(TSK_SELF);
	if (err < ER_OK) {
		D(0, ("map_volume: SetTaskSpace(TSK_SELF) %d\n", err));
		goto fin0;
	}

	/* ɥ쥹֤å */
	err = CheckSpaceR(mapaddr, SECB(size));
	if (err < ER_OK) {
		D(0, ("map_volume: CheckSpaceR %d\n", err));
		goto fin0;
	}

	/* ޥåץХåեإԡ */
	memcpy(wk->c_bufaddr, mapaddr, SECB(size));

	/* ɥ쥹֤׵ḵץڤؤ */
	err = SetTaskSpace(q->taskid);
	if (err < ER_OK) {
		D(0, ("map_volume: SetTaskSpace(q->taskid) %d\n", err));
		goto fin0;
	}

	wk->t_mapstart = pos;
	wk->t_mapsect  = size;
	wk->t_mapaddr  = mapaddr;
 fin0:
	return err;
}

/* ۥܥ塼फɤ߽Ф */
LOCAL	ERR	read_volume(DrvWork *wk, DevReq *q, W offset, W datacnt, W sec)
{
	/* ޥåץХåե׵ḵإԡ */
	if (q->memptr != NULL) {
		memcpy(q->memptr + SECB(datacnt),
		       wk->c_bufaddr + offset, SECB(sec));
	}

	return ER_OK;
}

/* ۥܥ塼ؤν񤭹 */
LOCAL	ERR	write_volume(DrvWork *wk, DevReq *q, W offset, W datacnt, W sec)
{
	ERR	err;

	/* 񤭹ߤػߤƤ */
	if (wk->c_diskinfo.protect) return ER_RONLY;

	/* ׵ḵޥåץХåեإԡ */
	if (q->memptr != NULL) {
		memcpy(wk->c_bufaddr + offset,
		       q->memptr + SECB(datacnt), SECB(sec));
	} else {
		memset(wk->c_bufaddr + offset, 0xe5, SECB(sec));
	}

	/* ɥ쥹֤򥵡Хץڤؤ */
	err = SetTaskSpace(TSK_SELF);
	if (err < ER_OK) {
		D(0, ("write_volume: SetTaskSpace(TSK_SELF) %d\n", err));
		goto fin0;
	}

	/* ޥåץХåեޥåΰإԡ */
	memcpy(wk->t_mapaddr + offset, wk->c_bufaddr + offset, SECB(sec));

	/* ɥ쥹֤׵ḵץڤؤ */
	err = SetTaskSpace(q->taskid);
	if (err < ER_OK) {
		D(0, ("write_volume: SetTaskSpace(q->taskid) %d\n", err));
		goto fin0;
	}
 fin0:
	return err;
}

/* ۥܥ塼ؤΥ */
LOCAL	ERR	rw_volume(DrvWork *wk, DevReq *q, DevRsp *r)
{
	ERR	err;
	W	i, size, pos, rsize, offset;

	D(3, ("rw_volume: datano %d datacnt %d memptr %x\n",
	      q->datano, q->datacnt, q->memptr));

	/* datacnt == 0ʤ񤭹߲ǽʥ֥å֤ */
	if (!q->datacnt) {
		err = ER_OK;
		rsize = wk->c_diskinfo.blockcont;
		goto fin0;
	} else {
		rsize = 0;
	}

	/* ѥ᡼Υå */
	if (q->datano + q->datacnt > wk->c_diskinfo.blockcont) {
		D(0, ("rw_volume: datano %d datacnt %d ER_PAR\n",
		      q->datano, q->datacnt));
		err = ER_PAR;
		goto fin0;
	}

	/* wk->c_mapmaxñ */
	for (i = 0; i < q->datacnt; i += wk->c_mapmax) {
		size = q->datacnt - i;		/* wk->c_mapmaxñ̤ʬ */
		if (size > wk->c_mapmax) size = wk->c_mapmax;

		/* ޥåפɬפкƥޥå */
		pos = q->datano + i;
		err = map_volume(wk, q, pos, size);
		if (err < ER_OK) {
			D(0, ("rw_volume: map_volume %d\n", err));
			goto fin0;
		}

		/* read/write */
		offset = SECB(pos - wk->t_mapstart);
		err = (q->cmd.cmd == DC_WRITE) ?
			write_volume(wk, q, offset, i, size) :
			read_volume(wk, q, offset, i, size);
		if (err < ER_OK) {
			D(0, ("rw_volume: {read,write}_volume %d\n", err));
			goto fin0;
		}

		rsize += size;
	}
	err = ER_OK;
 fin0:
	r->datacnt = rsize;
	return err;
}

/* write׵ */
LOCAL	ERR	vd_write(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return rw_volume(wk, q, r);

	switch (q->datano) {
	case	DN_DISKEVENT:		return write_dn_diskevent(wk, q, r);
	case	DN_DISKFORMAT:		return write_dn_diskformat(wk, q, r);
	case	DN_DISKINIT:		return write_dn_diskinit(wk, q, r);
	case	DN_DISKCMD:		return ER_NOSPT;
	default:			return ER_PAR;
	}
}

/* DN_DISKEVENT(r) */
LOCAL	ERR	read_dn_diskevent(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;

	D(3, ("read_dn_diskevent: datacnt %d memptr %x\n",
	      q->datacnt, q->memptr));

	len = (q->datacnt < sizeof(ID)) ? q->datacnt : sizeof(ID);

	memcpy(q->memptr, &wk->t_mbfid, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKINFO(r) */
LOCAL	ERR	read_dn_diskinfo(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;
	DiskInfo	di;

	D(3, ("read_dn_diskinfo: datacnt %d memptr %x\n",
	      q->datacnt, q->memptr));

	len = (q->datacnt < sizeof(di)) ? q->datacnt : sizeof(di);

	memcpy(q->memptr, &wk->c_diskinfo, len);

	r->datacnt = len;

	return ER_OK;
}

/* DN_DISKCHSINFO(r) */
LOCAL	ERR	read_dn_diskchsinfo(DrvWork *wk, DevReq *q, DevRsp *r)
{
	W	len;
	DiskCHSInfo	dc;

	D(3, ("read_dn_diskchsinfo: datacnt %d memptr %x\n",
	      q->datacnt, q->memptr));

	len = (q->datacnt < sizeof(dc)) ? q->datacnt : sizeof(dc);

	dc.cylinder = 1;
	dc.head     = 1;
	dc.sector   = wk->c_diskinfo.blockcont;
	memcpy(q->memptr, &dc, len);

	r->datacnt = len;

	return ER_OK;
}

/* read׵ */
LOCAL	ERR	vd_read(DrvWork *wk, DevReq *q, DevRsp *r)
{
	if (q->datacnt < 0) return ER_PAR;
	if (q->datano >= 0) return rw_volume(wk, q, r);

	switch (q->datano) {
	case	DN_DISKEVENT:		return read_dn_diskevent(wk, q, r);
	case	DN_DISKINFO:		return read_dn_diskinfo(wk, q, r);
	case	DN_DISKMEMADR:		return ER_NOSPT;
	case	DN_DISKPARTINFO:	return ER_PAR;
	case	DN_DISKCHSINFO:		return read_dn_diskchsinfo(wk, q, r);
	case	DN_DISKIDINFO:		return ER_NOSPT;
	default:			return ER_PAR;
	}
}	

/* open׵ */
LOCAL	ERR	vd_open(DrvWork *wk, DevReq *q, DevRsp *r)
{
	D(3, ("vd_open\n"));

	/* ۥܥ塼ब¸ߤʤ */
	if (!wk->c_attach) return ER_NOMDA;

	return ER_OK;
}

/* close׵ */
LOCAL	ERR	vd_close(DrvWork *wk, DevReq *q, DevRsp *r)
{
	D(3, ("vd_close%s\n", (q->cmd.cmd == DC_CLOSEALL) ? "all" : ""));

	/* ۥܥ塼ब¸ߤʤ */
	if (!wk->c_attach) return ER_NOMDA;

	/* Ȥʤ */
	if (q->cmd.cmd != DC_CLOSEALL) return ER_OK;

	return ctl_eject(wk);
}

/* abort׵ */
LOCAL	ERR	vd_abort(DrvWork *wk, DevReq *q, DevRsp *r)
{
	D(3, ("vd_abort\n"));

	/* ۥܥ塼ब¸ߤʤв⤷ʤ */
	if (!wk->c_attach) return ER_OK;

	return ctl_abort(wk, wk->t_tskid_normal);
}

/* Ƽ׵ */
LOCAL	ERR	vd_request(DrvWork *wk, DevReq *q, DevRsp *r)
{
	switch (q->cmd.cmd) {
	/* ̾׵ */
	case	DC_READ:	return vd_read(wk, q, r);
	case	DC_WRITE:	return vd_write(wk, q, r);
	case	DC_OPEN:	return vd_open(wk, q, r);
	case	DC_CLOSE:
	case	DC_CLOSEALL:	return vd_close(wk, q, r);
		break;

	/* ü׵ */
	case	DC_ABORT:	return vd_abort(wk, q, r);
	case	DC_SUSPEND:
	case	DC_RESUME:	return ER_OK;	/* ΤȤ⤷ʤ */

	/* ¾ */
	default:		return ER_NOSPT;
	}
}

/* ɥ饤С */
LOCAL	void	vd_task(UW calptn)
{
	ERR	err;
	RNO	rdvno;
	W	size;
	T_RTSK	rtsk;
	DevReq	q;
	DevRsp	r;
	DrvWork	*wk;

	/* μ */
	err = ref_tsk(&rtsk, TSK_SELF);
	if (err < ER_OK) {
		D(0, ("vd_task: ref_tsk %d\n", err));
		goto fin0;
	}
	wk = rtsk.exinf;

	while (1) {
		/* ׵Ԥ */
		err = acp_por(&rdvno, (VP)&q, &size, wk->t_porid, calptn);
		if (err < ER_OK) goto fin1;

		/* ʥѥåȤ̵ */
		if (size != sizeof(q)) {
			D(0, ("vd_task: bad size %d\n", size));
			continue;
		}

		D(4, ("vd_task: cmd %d datano %d datacnt %d memptr %x\n",
		      q.cmd.cmd, q.datano, q.datacnt, q.memptr));

		/* ֤ڤؤ */
		err = taskspace_select(&q);
		if (err < ER_OK) {
			D(0, ("vd_task: taskspace_select %d\n", err));
		}

		/* ѥѥåȤν׵μ¹ */
		r.devid     = q.devid;
		r.cmd       = q.cmd;
		r.datano    = q.datano;
		r.datacnt   = 0;
		r.error.err = (err < ER_OK) ? err : vd_request(wk, &q, &r);

		/* ǥ֤ؤ */
		err = rpl_rdv(rdvno, (VP)&r, sizeof(r));
		if (err < ER_OK) D(0, ("vd_task: rpl_rdv %d\n", err));
	}

 fin1:
	del_por(wk->t_porid);
 fin0:
	exd_tsk();
}

/* ɥ饤еư */
EXPORT	ERR	vd_start(DrvWork *wk)
{
	WERR	err;
	T_CTSK	ctsk;
	T_CPOR	cpor;

	/* ǥ֥ݡȺ */
	cpor.exinf   = (VP)CH4toW('v', 'd', 'd', 'a' + wk->drvno);
	cpor.poratr  = TA_NULL;
	cpor.maxcmsz = sizeof(DevReq);
	cpor.maxrmsz = sizeof(DevRsp);
	err = vcre_por(&cpor);
	if (err < ER_OK) goto fin0;
	wk->t_porid = (ID)err;

	/* ̾׵ */
	ctsk.exinf   = wk;
	ctsk.task    = vd_task;
	ctsk.itskpri = VDTASK_PRI;
	ctsk.stksz   = VDTASK_STKSZ;
	ctsk.tskatr  = TA_HLNG | TA_RNG0;
	err = vcre_tsk(&ctsk);
	if (err < ER_OK) goto fin1;
	wk->t_tskid_normal = (ID)err;

	/* ü׵ */
	err = vcre_tsk(&ctsk);
	if (err < ER_OK) goto fin2;
	wk->t_tskid_abort = (ID)err;

	/* ư̾׵ */
	err = sta_tsk(wk->t_tskid_normal, D_NORM_PTN);
	if (err < ER_OK) goto fin3;

	/* ưü׵ */
	err = sta_tsk(wk->t_tskid_abort, D_ABORT_PTN);
	if (err < ER_OK) goto fin4;

	goto fin0;

/*fin5:*/
	ter_tsk(wk->t_tskid_abort);
 fin4:
	ter_tsk(wk->t_tskid_normal);
 fin3:
	del_tsk(wk->t_tskid_abort);
 fin2:
	del_tsk(wk->t_tskid_normal);
 fin1:
	del_por(wk->t_porid);
 fin0:
	return err;
}

/* ɥ饤нλ */
EXPORT	ERR	vd_finish(DrvWork *wk)
{
	if (wk != NULL) {
		del_por(wk->t_porid);		/* 򻦤мǤ */
	}
	
	return ER_OK;
}
